﻿using System;
using System.Collections.Generic;
using Features.UI;
using UnityEngine;
using UnityEngine.UI;

namespace Commons.UI
{
    public abstract class BaseUI : MonoBehaviour, IBaseUI
    {
        private int depth;
        private Animation startAnimation, endAnimation;

        public int Depth { get { return depth; } set { depth = value; } }
        public Animation EndAnimation { get { return endAnimation; } }
        public Animation StartAnimation { get { return startAnimation; } }

        public abstract void Show(params object[] datas);
        public abstract void Hide(params object[] datas);

        public abstract void AdditionalShowFunction(params object[] datas);
        public abstract void AdditionalHideFunction(params object[] datas);
    }
}