﻿using System;
using UnityEngine;

namespace Commons.UI
{
    public abstract class PopupUI : BaseUI
    {
        private Animation backAnimation;
        private Animation panelAnimation;

        private bool hideLife;

        void Start()
        {
            backAnimation = transform.GetChild(0).GetComponent<Animation>();
            panelAnimation = transform.GetChild(1).GetComponent<Animation>();
        }

        void Update()
        {
            if (!hideLife) return;

            if (!backAnimation.isPlaying && !panelAnimation.isPlaying)
            {
                transform.localPosition = new Vector3(-10000, -10000, 0);
                hideLife = false;
            }
        }

        public override void Show(params object[] datas)
        {
            transform.localPosition = new Vector3(0, 0, 0);
            
            backAnimation.Play("StartAnimation");
            panelAnimation.Play("StartAnimation");

            AdditionalShowFunction(datas);
        }

        public override void Hide(params object[] datas)
        {
            backAnimation.Play("CloseAnimation");
            panelAnimation.Play("CloseAnimation");

            hideLife = true;

            AdditionalHideFunction(datas);
        }
    }
}