﻿using UnityEngine;

namespace Utilities.Edit
{
    public static class EditorExtention
    {
        public static GameObject CreateChildObject(Transform transform) { return createChildObject(transform); }
        public static GameObject CreateChildObject(Transform transform, string name) { return createChildObject(transform, name); }
        public static GameObject CreateChildObject(Transform transform, string name, params System.Type[] types) { return createChildObject(transform, name, types); }
        
        private static GameObject createChildObject(Transform transform, string name = "" , params System.Type[] types)
        {
            GameObject obj = new GameObject();
            obj.name = name;

            for (int i = 0; i < types.Length; i++)
                obj.AddComponent(types[i]);

            obj.transform.SetParent(transform, false);

            return obj;
        }

        public static void AddComponent(GameObject obj, params System.Type[] datas)
        {
            addComponent(obj, datas);
        }

        private static void addComponent(GameObject obj, params System.Type[] datas)
        {
            for (int i = 0; i < datas.Length; i++)
                obj.AddComponent(datas[i]);
        }

        public static bool GetFileCheckInDirectory(string path)
        {
            System.IO.DirectoryInfo dirPath = new System.IO.DirectoryInfo(Application.dataPath + "/" + path);

            return dirPath.Exists;
        }

        public static bool GetFileCheckInFile(string path, string name, string extention)
        {
            System.IO.FileInfo filePath = new System.IO.FileInfo(Application.dataPath + "/" + path + name + "." + extention);

            return filePath.Exists;
        }

        public static Vector2 GetMainGameViewSize()
        {
            System.Type T = System.Type.GetType("UnityEditor.GameView,UnityEditor");
            System.Reflection.MethodInfo GetSizeOfMainGameView = T.GetMethod("GetSizeOfMainGameView", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Static);
            System.Object Res = GetSizeOfMainGameView.Invoke(null, null);
            return (Vector2)Res;
        }
    }
}