﻿using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

namespace Features.UI
{
    public interface IBaseUI
    {
        /// <summary>
        /// 깊이
        /// </summary>
        int Depth { get; }
        
        /// <summary>
        /// 시작시 애니메이션
        /// </summary>
        Animation StartAnimation { get; }

        /// <summary>
        /// 종료시 애니메이션
        /// </summary>
        Animation EndAnimation { get; }

        /// <summary>
        /// 보여주기
        /// </summary>
        void Show(params object[] datas);

        /// <summary>
        /// 숨기기
        /// </summary>
        void Hide(params object[] datas);

        /// <summary>
        /// Show 함수에 추가적으로 할 부분을 자식에서 가져올 수 있습니다.
        /// </summary>
        void AdditionalShowFunction(params object[] datas);

        /// <summary>
        /// Hide 함수에 추가적으로 할 부분을 자식에서 가져올 수 있습니다.
        /// </summary>
        void AdditionalHideFunction(params object[] datas);
    }
}